<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.useractivitystatistical_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="userInfo" slot-scope="scope">
        <div style="display: flex;"  v-if="scope.row.loginWebVO">
          <div style="display: flex;justify-content: center;align-items: center;">
            <el-avatar size="large" :src="scope.row.loginWebVO.avatar"></el-avatar>
          </div>
           <div style="padding: 10px;">
             <div >昵称：{{scope.row.loginWebVO.nickName}}</div>
             <div>手机：{{scope.row.loginWebVO.phone}}</div>
           </div>
        </div>
        <div style="display: flex;" v-else>
          <div style="display: flex;justify-content: center;align-items: center;">
            <el-avatar size="large" src="https://yyzs.nanyue6688.com/obsfile/0ad6d53ecf5448bfb9694fdaed27eadc-avatar.png"></el-avatar>
          </div>
           <div style="padding: 10px;">
             <div style="color: #DD6161;">用户已注销</div>
           </div>
        </div>
      </template>
      <template slot="rank" slot-scope="scope" v-if="scope.row.loginWebVO">
        <el-tag effect="dark">
          {{scope.row.loginWebVO.rank}}
        </el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/useractivitystatistical/useractivitystatistical";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          menu:false,
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              hide:true,
              label: "用户id",
              prop: "userId",
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              label: "选手信息",
              serach:true,
              prop: "userInfo",
              slot:true
            },
            {
              label: "排名",
              prop: "rank",
              slot:true
            },
            {
              hide:true,
              label: "活动id",
              prop: "activityId",
              rules: [{
                required: true,
                message: "请输入活动id",
                trigger: "blur"
              }]
            },
            {
              label: "活动可用热力值",
              prop: "usableHotValue",
              rules: [{
                required: true,
                message: "请输入可用热力值",
                trigger: "blur"
              }]
            },
            {
              label: "活动总热力值",
              prop: "totalHotValue",
              rules: [{
                required: true,
                message: "请输入总热力值",
                trigger: "blur"
              }]
            },
            {
              label: "活动可用积分",
              prop: "usablePointsValue",
              rules: [{
                required: true,
                message: "请输入可用积分",
                trigger: "blur"
              }]
            },
            {
              label: "活动总积分",
              prop: "totalPointsValue",
              rules: [{
                required: true,
                message: "请输入总积分",
                trigger: "blur"
              }]
            },
            {
              label: "用户在此活动收到的总现金",
              prop: "totalCash",
              rules: [{
                required: true,
                message: "请输入用户在此活动收到的总现金",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.useractivitystatistical_add, false),
          viewBtn: this.vaildData(this.permission.useractivitystatistical_view, false),
          delBtn: this.vaildData(this.permission.useractivitystatistical_delete, false),
          editBtn: this.vaildData(this.permission.useractivitystatistical_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
